import os
import sys

cmd_args = sys.argv

folder = cmd_args[1]
start_term = cmd_args[2]
end_term = cmd_args[3]

index = {}
term_loc = {}


# find closest after start term/before end term if the exact match doesn't exist
# uses binary search to narrow down
def find_closest(key, direction):
    l = len(index)
    low, high = 0, l - 1

    while l > high > low > -1:
        mid = low + (high - low) // 2
        word = index[mid][0]
        if key < word:
            high = mid - 1
        else:
            low = mid + 1

    last_word = index[low][0]
    if direction == 1 and key < last_word: return low
    if direction == 1 and key > last_word: return low + 1
    if direction == -1 and key < last_word: return low - 1
    if direction == -1 and key > last_word: return low


for file in os.listdir(folder):

    if file.endswith(".txt"):
        file_num = int(file.split(".")[0])
        char_offset = 0
        with open(os.path.join(folder, file), 'r') as doc:
            for line in doc:
                for term in line.split():
                    term = term.strip("\n.").lower()
                    char_offset += 1
                    if term in index:
                        index[term][0].add(file_num)
                        index[term][1] += 1
                        index[term][2].append((file_num, char_offset))
                    else:
                        index[term] = [{file_num}, 1, [(file_num, char_offset)]]

sorted_index = sorted(index.items(), key=lambda x: x[0])

index = list(sorted_index)
for i in range(len(index)):
    term_loc[index[i][0]] = i

if start_term in term_loc:
    start = term_loc[start_term]
else:
    start = find_closest(start_term, 1)

if end_term in term_loc:
    end = term_loc[end_term]
else:
    end = find_closest(end_term, -1)

if start > end: print('No words found in the given range.')

# print results
for i in range(start, end + 1):
    print(index[i][0])
    param = index[i][1]
    print(len(param[0]), end=",")
    print(param[1], end=",")
    l = len(param[2])
    for i in range(l - 1):
        print(param[2][i], end=",")
    print(param[2][l - 1])
